CREATE OR REPLACE PACKAGE BODY gcourse_pkg AS
--------------------------------------------------------------------------------
--[*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*]
--------------------------------------------------------------------------------
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_                             _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_   COURSE MANIPULATION PACKAGE   _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_                             _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--------------------------------------------------------------------------------
--[*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*]
--------------------------------------------------------------------------------
--------------------------------------------------------------------
--##################################################################
-- printErrorMessage
--##################################################################
PROCEDURE showCourse( course IN VARCHAR2)
IS	
	acourse XXcoursesXX%ROWTYPE;
BEGIN
	select * INTO acourse FROM XXcoursesXX WHERE course=courseTitle;
	htp.p('<html> <header><title>Course Information</title></header>');
	htp.p('<body bgcolor=white>');
	htp.p('<h1>Course Information</h1>');
	htp.p('<hr>');
	htp.p(' <table bgcolor=pink><th>');
	htp.p('<table bgcolor=yellow cellpadding=6 border=5  >');
	htp.p('<tr><td width=250>');
	htp.p('<b>Course </b></td><td>'||acourse.courseTitle);
	htp.p('</tr><tr><td>');
	htp.p('<b>Instructor</b></td><td>'||acourse.instructor||'</td>');
	htp.p('</tr><tr><td>');
	htp.p('<b>Instructor URL </b></td><td>'||acourse.insurl||'</td>');
	htp.p('</tr><tr><td>');
	htp.p('<b>Instructor email </b></td><td>'||acourse.insemail||'</td>');
	htp.p('</tr><tr><td>');
	htp.p('<b>TA</b></td><td>'||acourse.ta||'</td>');
	htp.p('</tr><tr><td>');
	htp.p('<b>TA URL </b></td><td>'||acourse.taurl||'</td>');
	htp.p('</tr><tr><td>');
	htp.p('<b>TA email </b></td><td>'||acourse.taemail||'</td>');
	htp.p('</tr><tr><td>');
	htp.p('<b>Other Team Names</b></td><td>'||acourse.team||'</td>');
	htp.p('</tr><tr><td>');
	htp.p('<b>Course URL</b></td><td>'||acourse.url||'</td>');
	htp.p('</tr><tr><td>');
	htp.p('<b>Number of Assignments</b></td><td>'||acourse.numberofass);
	htp.p('<b>Grading Type</b>'||acourse.assType||'</td>');
	htp.p('</tr><tr><td>');
	htp.p('<b>Comments</b></td><td>');
	htp.p(acourse.Notes||'</td>');
	htp.p('</tr>');
	htp.p('');
	htp.p('</table>');
	htp.p('</th>');
	htp.p('</table>');
	htp.p('<hr>');
	htp.p('</body></html>');
END showCourse;
--------------------------------------------------------------------
--##################################################################
-- courseUpdate
--##################################################################
	PROCEDURE courseUpdate( unum    IN VARCHAR2,
				oldtitle IN VARCHAR2, 
				cname	IN VARCHAR2,
				Vterm	IN VARCHAR2,
				Vyear	IN VARCHAR2,
				Vinstructor	IN VARCHAR2,
				Vinsurl	IN VARCHAR2,
				Vinsemail	IN VARCHAR2,
				Vta	IN VARCHAR2,
				Vtaurl	IN VARCHAR2,
				Vtaemail	IN VARCHAR2,
				Vteam	IN VARCHAR2,
				Vurl	IN VARCHAR2,
				Vnumberofass	IN VARCHAR2,
				gtype	IN VARCHAR2,
				comments	IN VARCHAR2
				)
IS	
	title VARCHAR2(200);
BEGIN
	title :=cname||Vterm||Vyear;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,title,'courseUpdate') THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	UPDATE XXcoursesXX c
	SET  	c.courseTitle=title ,
		c.courseName=cname,
		c.term=Vterm,
		c.year=Vyear,
		c.instructor=Vinstructor ,
		c.insurl= Vinsurl,
		c.insemail=Vinsemail ,
		c.ta=Vta ,
		c.taurl= Vtaurl,
				c.taemail=Vtaemail ,
				c.team=Vteam ,
				c.url=Vurl ,
				c.numberofass=Vnumberofass ,
				c.asstype=gtype,
				c.Notes=comments
	WHERE oldtitle=courseTitle;
	IF SQL%NOTFOUND THEN
		INSERT INTO XXcoursesXX 
		VALUES (title,cname	,
				Vterm	,
				Vyear	,
				Vinstructor	,
				Vinsurl	,
				Vinsemail	,
				Vta	,
				Vtaurl	,
				Vtaemail	,
				Vteam	,
				Vurl	,
				Vnumberofass	,
				gtype	,
				comments,
				'NO','YES','NO'	);
	END IF;
	COMMIT;
	showCourse(title);
	EXCEPTION
		WHEN DUP_VAL_ON_INDEX THEN
			gsystem_pkg.printErrorPage('This course already exists, you can not duplicate the course name.');
END courseUpdate;
--------------------------------------------------------------------
--##################################################################
-- courseDelete(course IN VARCHAR2)
--##################################################################
PROCEDURE courseDelete(unum IN VARCHAR2,crsTitle IN VARCHAR2, choice IN VARCHAR2)
IS	
BEGIN
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,crsTitle,'courseManipulationDELETEapproved') THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF CHOICE like '%YES%' THEN
		DELETE	FROM XXcoursesXX WHERE courseTitle=crsTitle;
		DELETE  FROM XXgrade_customizeXX gc WHERE gc.course=crsTitle;
		DELETE  FROM XXstudentsXX s  WHERE s.course=crsTitle;
		DELETE  FROM XXgradesXX g  WHERE g.course=crsTitle;
		DELETE  FROM XXsurveyXX s WHERE s.course=crsTitle;
		COMMIT;
		htp.p('<html>COURSE DELETED</html>');
	ELSIF CHOICE like '%NO%' THEN
		HTP.P('<html>DELETE CANCELLED</html>');
	END IF;
END courseDelete;
--------------------------------------------------------------------
--##################################################################
-- courseDeletePage(course IN VARCHAR2)
--##################################################################
PROCEDURE courseDeletePage(unum	IN VARCHAR2,course IN VARCHAR2)
IS	
BEGIN
	htp.p('<html> <header><title>Course Delete Page</title></header>');
	htp.p('<body bgcolor=red >');
	htp.p('<h1>Course Delete Warning</h1>');
	htp.p('<h2>
You are going to delete the course '||course||' from the database:<br>
	If you do so, you will not be able to see anymore the records including course infromation and customizations, all the student records registered to this course.
</h2>');
	htp.p('<hr>');
	htp.p('<form action='||gsystem_pkg.cgi||'gcourse_pkg.courseDelete');
	htp.p('method="POST">');
	htp.p('<input type=hidden name=unum value="'||unum||'"> ');
	htp.p('<input type=hidden name=crsTitle value="'||course||'"> ');
	htp.p('<font color=white size=+1>');
	htp.p('<input type=submit name=choice value=" YES, remove ALL! "> ');
	htp.p('<input type=submit name=choice value=" NO, cancel it! ">');
	htp.p('</font>');
	htp.p('</form>');
	htp.p('</body>');
	htp.p('</html>');
END courseDeletePage;
--------------------------------------------------------------------
--##################################################################
-- gradingCustimezePage
--##################################################################
PROCEDURE gradingCustomizePage(unum IN VARCHAR2,course IN VARCHAR2)
IS	
	agrade		XXgrade_customizeXX%ROWTYPE;
	grade_cur 	GenericCurType;
BEGIN
	htp.p('<html>
	<script language="JavaScript">
	function closeMe(win) {
		self.close();
	}
	</script>');
	htp.p('<body bgcolor=white ><h2><font color=pink FACE="Arial, Helvetica">'||course||' grading customizations: </font></h2> ');
	htp.p('
	<form action='||gsystem_pkg.cgi||'gcourse_pkg.gradingCustomize    method="POST">
	<input type=hidden name=unum value="'||unum||'"><input type=hidden name=courseTitle value="'||course||'"> ');
	IF NOT grade_cur%ISOPEN THEN      -- open the cursor if
	            gsystem_pkg.open_cv (grade_cur,'XXgrade_customizeXX',course);    -- not open yet
        END IF;
 	-- Fetch rows into PL/SQL table
	LOOP
		FETCH grade_cur INTO agrade;
                EXIT WHEN grade_cur%NOTFOUND;
		htp.p('<input type=radio name=oldGrade value="'
		|| agrade.grade||'">'||agrade.grade||' '|| agrade.numeric || ' <br>');
        END LOOP;
        CLOSE grade_cur;
		htp.p('<input type=radio name=oldGrade value="" CHECKED> <br>');
	htp.p('<hr><b>New Grade</b><input name=newGrade size=15 value="">
		<b>Points</b><input name=newNumeric size=5 value="">	<br>');
	htp.p('<input type=submit name=request value="ADD(overwrite)"> ');
	htp.p('<input type=submit name=request value="DELETE">');
	htp.p('');
	htp.p('</form>');
	htp.p('<form><input type=button value="CLOSE WINDOW" onClick="closeMe(this)">');
	htp.p('</body>');
	htp.p('</html>');
END gradingCustomizePage;
--------------------------------------------------------------------
--##################################################################
-- gradingCustimeze;
--##################################################################
PROCEDURE gradingCustomize(unum IN VARCHAR2,courseTitle IN VARCHAR2,oldGrade IN VARCHAR2, newGrade IN VARCHAR2,newNumeric IN NUMBER, request IN VARCHAR2)
IS
	noinsertion EXCEPTION;	
BEGIN
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,courseTitle,'gradingCustomize') THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF request='ADD(overwrite)' THEN
		UPDATE XXgrade_customizeXX gc
		SET  	
			gc.grade=newGrade,
			gc.numeric=newNumeric
		WHERE gc.course=courseTitle AND   gc.grade=newGrade ;
		COMMIT;
		IF SQL%NOTFOUND THEN
			IF courseTitle IS NULL OR newGrade IS NULL THEN
				RAISE noinsertion;
			END IF;
			INSERT INTO XXgrade_customizeXX 
			VALUES (courseTitle,newGrade,newNumeric);
			COMMIT;
		END IF;
	ELSIF request='DELETE' THEN
		DELETE FROM XXgrade_customizeXX gc WHERE gc.grade=oldGrade 
				AND gc.course=courseTitle;
		COMMIT;
	END IF;
	gradingCustomizePage(unum,courseTitle);
	EXCEPTION
		WHEN noinsertion THEN
			IF courseTitle IS NULL THEN
				gsystem_pkg.printErrorPage('This course not registered yet. Please update after submitting the course.');
			ELSIF newGrade IS NULL THEN
				gsystem_pkg.printErrorPage('Grade field can not be empty.');
			END IF;
END gradingCustomize;
--------------------------------------------------------------------
--##################################################################
-- nextQuestion
--##################################################################
FUNCTION nextQuestion RETURN VARCHAR2
IS	qn NUMBER(2) DEFAULT 0;
BEGIN
	SELECT MAX(qid) INTO qn FROM xxquestionsxx ;
	IF qn IS NULL THEN qn:=0; END IF;
	RETURN TO_CHAR(qn+1);
	EXCEPTION
		WHEN NO_DATA_FOUND THEN
			RETURN '1';
END nextQuestion;
--------------------------------------------------------------------
--##################################################################
-- surveyPage
--##################################################################
PROCEDURE surveyPage(crsTitle IN VARCHAR2)
IS	
	question		XXquestionsXX%ROWTYPE;
--	survey_cur 	GenericCurType;
	previous	VARCHAr2(50) :='default start';
BEGIN
	htp.bp('<html>
	<script language="JavaScript">
	function closeMe(win) {
		self.close();
	}
	function updateSN(form) {
		if ( form.skip.selectedIndex!=0)
			this.document.SBMT.surveyname.value=form.skip.options[form.skip.selectedIndex].value;
	}
	function submitD() {
		this.document.SBMT.request.value="DELETE the survey from the";
		this.document.SBMT.submit();
	}

	function submitQ(form) {
		this.document.SBMT.list.value=", ";
		for (var i=0; i<form.elements.length;i++){
			if (form.elements[i].checked)
				this.document.SBMT.list.value+=form.elements[i].value;
		}
	this.document.SBMT.submit(); //	open(this.document.SBMT.submit(),"dfsfsdfsdfs","width=100");
	}	

	</script>');
	htp.p('<body bgcolor=white ><h2><font color=pink FACE="Arial, Helvetica"> Survey questions: </font></h2> ');
	htp.p('	<form name=q> <table><tr><td><b><center>QUESTION</td><td><b><center>CATEGORY</td></tr>'	);
	htp.p('<p>');
	FOR question IN (SELECT * FROM XXquestionsXX q 	ORDER BY category ASC,qid ASC) LOOP
		htp.p('<tr><td><input type=checkbox name=q'||question.qid||' value="'||question.qid||', "><b> '||question.qid||'.</b> '|| question.text||' </td><td>'|| question.category || '</td></tr>');
        END LOOP;
	htp.bp('</table></form>
	<form action='||gsystem_pkg.cgi||'gcourse_pkg.survey  name=SBMT method="POST">
	<font color=blue><input type=button name=request value="ADD(overwrite) selected list to '||crsTitle||' " onClick="submitQ(top.document.q)"> for the survey <input name=surveyname size=10 value="registration"> <br>

	<font size=+5>( </font><font size=-1 color=red><input type=submit name=request  value="DELETE the survey from the  '||crsTitle||' : " onClick="submitD();">  <select name=skip onChange="updateSN(this.form)"><option value=""> SURVEY
	');
	FOR sl IN (SELECT surName  FROM XXsurveyListXX s WHERE (s.course=crsTitle) ORDER BY surName) LOOP
		IF NOT previous = sl.surName THEN
			htp.p('	<option value="'||sl.surName ||'">'||sl.surName );
			previous:=sl.surName ;
		END IF;
	END LOOP;
	htp.bp('</select></font> <font size=+5> )</font>
	</font><p>
	<table bgcolor=gray><th><hr><font color=white>
	<input type=submit name=request 	value=" DELETE selected questions " onClick="submitQ(top.document.q)">
	<hr> <input type=submit name=request 	value=" ADD(overwrite) question "></font><br>
	Number<input name=qn size=2 value="'||nextQuestion||'">
	Question<input name=qst size=15 value="">
	Category<input name=catg  size=10 value="">
	<input type=hidden name=crsTitle value="'||crsTitle||'"><input type=hidden name=list value="">
	<hr></th></table></form>
	');
	htp.p('<p><p>');
	htp.bp('<form><input type=button value="CLOSE WINDOW" onClick="closeMe(this)">
			<input type=button value="RELOAD DOCUMENT" onClick=top.document.location="gcourse_pkg.surveyPage?crsTitle='||crsTitle||'">
	');
	htp.p('</body>');
	htp.p('</html>');
END surveyPage; --onClick="top.document.location.reload()">
--------------------------------------------------------------------
--##################################################################
-- survey
--##################################################################
PROCEDURE survey(request IN VARCHAR2,surveyname IN VARCHAR2,skip IN VARCHAR2,qn IN NUMBER, qst IN VARCHAR2,catg IN VARCHAR2,crsTitle IN VARCHAR2,list IN VARCHAR2)
IS	
	question		XXquestionsXX%ROWTYPE;
	sl			XXsurveyListXX%ROWTYPE;
BEGIN --htp.p('<h2>'||list);
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
--	IF  NOT gsystem_pkg.accessPermit(unum,crsTitle,'survey') THEN
--		RETURN;
--	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF request like '%ADD(overwrite) selected list to%' THEN
		FOR question IN (SELECT * FROM XXquestionsXX q 	 WHERE list like '%, '||TO_CHAR(q.qid)||',%') LOOP
			UPDATE XXsurveyListXX s
			SET  s.text=question.text,s.category=question.category
			WHERE s.course=crsTitle AND s.qid=question.qid AND s.surName=surveyname;
			IF SQL%NOTFOUND THEN
				INSERT INTO XXsurveyListXX VALUES (crsTitle,surveyname,question.qid,question.text,question.category);
			END IF;
        	END LOOP;
		FOR sl IN (SELECT * FROM XXsurveyListXX s WHERE (s.course=crsTitle AND s.surName=surveyname AND  (NOT list like '%, '||TO_CHAR(qid)||',%'))) LOOP
			DELETE FROM XXsurveyListXX ds WHERE ds.course=crsTitle AND sl.qid=ds.qid AND ds.surName=surveyname;
		END LOOP;
		COMMIT;
		std.commandServer(crsTitle,NULL,'COURSE SURVEY',surveyname);
		RETURN;		
	ELSIF request like '%ADD(overwrite) question%' THEN
		UPDATE XXquestionsXX SET text=qst,category=catg WHERE qn=qid;
		IF SQL%NOTFOUND THEN
			INSERT INTO XXquestionsXX VALUES (qn,qst,catg);
		END IF;
	ELSIF request like '%DELETE selected questions%' THEN
		DELETE FROM XXquestionsXX WHERE list like '%, '||TO_CHAR(qid)||',%' ;
	ELSIF request like '%DELETE the survey from the%' THEN
		DELETE FROM XXsurveyListXX WHERE course=crsTitle AND surName=surveyname;
		DELETE FROM XXsurveyXX WHERE course=crsTitle AND surName=surveyname;
	END IF;
	COMMIT;
	surveyPage(crsTitle);
END survey;
-------------------------------------------------------------------
-- *<*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><>*
-- *<*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><>*
-------------------------------------------------------------------
--------------------------------------------------------------------
--##################################################################
-- courseManipulationPage
--##################################################################
PROCEDURE courseManipulationPage(unum IN VARCHAR2)
IS
	acourse		XXcoursesXX%ROWTYPE;
	course_cur 	GenericCurType;
	yy		VARCHAR2(2);
	today		DATE;
	last		VARCHAR2(100);
BEGIN
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,NULL,'courseManipulationPage') THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	htp.p('<html>');
	htp.p('<header>');
	htp.p('<title>NPAC Course Page</title>');
	htp.p('</header>');
	htp.p('<body bgcolor=white>');
	htp.p('<table cellspacing=1 cellpadding=0 border=0>');
	htp.p('<tr><td colspan=2 bgcolor=pink><br></td></tr>');
	htp.p('<tr>');
	htp.p('<td width=100 bgcolor=pink align=center valign=middle>');
	htp.p('<a href=http://www.npac.syr.edu/>');
	htp.p('<font size=+1>');
	htp.p('<b>NPAC</b>');
	htp.p('</font>');
	htp.p('</a>');
	htp.p('</td>');
	htp.p('<td><ul>');
	htp.p('<b><font size=+1>'); 	
	htp.p('Course Records</font><br>');
	htp.p('Please select the course to manipulate.');
	htp.p('</ul></td>');
	htp.p('</tr>');
	htp.p('');
	htp.p('<tr><td colspan=2 bgcolor=pink><br></td></tr>');
	htp.p('');
	htp.p('<tr>');
	htp.p('<td bgcolor=pink><br></td>');
	htp.p('');
	htp.p('<td><ul><ul>');
	htp.p('<form action='||gsystem_pkg.cgi||'gcourse_pkg.courseManipulation');
	htp.p('method="POST">');
		htp.p('<input type=hidden name=unum  value="'||unum||'"> ');
	htp.p('<br>');
	htp.p('<table border=1 cellspacing=0 cellpadding=5><tr><td><b> ');
	IF NOT course_cur%ISOPEN THEN      -- open the cursor if
	            gsystem_pkg.open_cv (course_cur,'XXcoursesXX','');    -- not open yet
        END IF;
 	-- Fetch rows into PL/SQL table
	last :='starting';
	LOOP
		FETCH course_cur INTO acourse;
                EXIT WHEN course_cur%NOTFOUND;
		IF (NOT last=acourse.courseName) THEN
			htp.p('<input type=radio name=course value="'|| acourse.courseName||'">'||acourse.courseName||'<br>');
		END IF;
		last:=acourse.courseName;
        END LOOP;
        CLOSE course_cur;
	-- for the case of no course present or selected
	htp.p('<input type=radio name=course value="" CHECKED><br>');
	htp.p('<select name=term>');
	today:=SYSDATE;
	yy:=SUBSTR(TO_CHAR(SYSDATE),8,2);
	IF today > TO_DATE('24-AUG-'||yy) THEN
		htp.p('<option value="Fall" >Fall<option value="Spring">Spring<option value="Summer">Summer');
	ELSIF today > TO_DATE('24-MAY-'||yy)  THEN
		htp.p('<option value="Summer">Summer<option value="Fall" >Fall<option value="Spring">Spring');
	ELSE	htp.p('<option value="Spring">Spring<option value="Summer">Summer<option value="Fall" >Fall');
	END IF;
	htp.p('</select>');
	htp.p('<input name=year value='||yy||' size=4><br>');
-- ---------------
	htp.p('<b><font color=black size=+1 FACE="Arial,Helvetica" >');
	htp.p('<input type=submit name="request" value="BROWSE">');
	htp.p('<input type=submit name="request" value="UPDATE">');
	htp.p('<font color=red>');
	htp.p('<input type=submit name="request" value="Delete"></font>');
	htp.p('</td></tr></table>');
	htp.p('<b><font color=black size=+1 FACE="Arial,Helvetica" >	
		<input type=submit name="request" value="ADD NEW"></font></b>');
	htp.p('</form>');
	htp.p('</ul></ul></td>');
	htp.p('</tr>');
	htp.p('<tr><td colspan=2 bgcolor=red><br></td></tr>');
	htp.p('</table>');
	htp.p('<br>');
	htp.p('</body>');
	htp.p('</html>');
	htp.p('');
END courseManipulationPage;
--------------------------------------------------------------------
--##################################################################
-- courseManipulation
--##################################################################
PROCEDURE courseManipulation(	unum	IN VARCHAR2,
				course 	IN VARCHAR2,
				term   	IN VARCHAR2,
				year 	IN VARCHAR2,
				request IN VARCHAR2)
IS	
	acourse		XXcoursesXX%ROWTYPE;
	yy		VARCHAR2(2);
	today		DATE;
	crsTitle	VARCHAR2(60);
BEGIN
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,NULL,'courseManipulation'||request) THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	crsTitle := course||term||year;
	IF UPPER(request) LIKE '%' || 'BROWSE' || '%' THEN
		showCourse(crsTitle);
		RETURN;
	ELSIF UPPER(request) LIKE '%' || 'UPDATE' || '%' THEN
		SELECT * INTO acourse
		FROM XXcoursesXX WHERE courseTitle=crsTitle;
	ELSIF UPPER(request) LIKE '%' || 'DELETE' || '%' THEN
		courseDeletePage(unum,course||term||year);
		RETURN;
	ELSIF UPPER(request) LIKE '%' || 'NEW' || '%' THEN
		today:=SYSDATE;
		yy:=SUBSTR(TO_CHAR(SYSDATE),8,2);
		IF today > TO_DATE('24-AUG-'||yy) THEN
			acourse.term:='Fall';
		ELSIF today > TO_DATE('24-MAY-'||yy) THEN
			acourse.term:='Summer';
		ELSE		acourse.term:='Spring';
		END IF;
		acourse.numberOfass:=0;
		acourse.courseName:='';
		acourse.year:=SUBSTR(TO_CHAR(SYSDATE),8,2);
	END IF;
------------------------html----------------------start here--------------
	htp.p('<html> <header><title>Course update</title></header>');
	htp.p('<SCRIPT LANGUAGE="JavaScript">');
	htp.p(' var crsT="'||acourse.courseTitle||'";');
	htp.bp('
function customize(form){ 
	crsT=this.document.cf.cname.value+this.document.cf.Vterm.options[this.document.cf.Vterm.options.selectedIndex].text+this.document.cf.Vyear.value;
		');
	IF UPPER(request) LIKE '%NEW%' THEN
		htp.bp('
	var crsTitle=prompt("This course is not submitted yet. Please confirm the course title and/or update it as you will submit: ",crsT); 
		');
	END IF;
	htp.bp('
	var adr="'||gsystem_pkg.cgi||'gcourse_pkg.gradingCustomizePage?unum='||unum||'&'||'course="+crsT;
	win=open(adr,"customize","resizable=yes,width=450");
	if (form.gtype.options[0].selected) 
		alert("Numeric option selected.!");
}
function survey(form){ 
	crsT=this.document.cf.cname.value+this.document.cf.Vterm.options[this.document.cf.Vterm.options.selectedIndex].text+this.document.cf.Vyear.value;
	');
	IF UPPER(request) LIKE '%NEW%' THEN
	htp.bp('
	var crsTitle=prompt("This course is not submitted yet. Please confirm the course title and/or update it as you will submit: ",crsT); 
	');
	END IF;
	htp.bp('
	var adr="'||gsystem_pkg.cgi||'gcourse_pkg.surveyPage?crsTitle="+crsT;
	win=open(adr,"survey","resizable=yes");
}
	');
	htp.p('</script>');
	htp.p('<body bgcolor=white name=merkez>');
	htp.p('<h1>Course Information Form</h1>');
	htp.p('<FORM action='||gsystem_pkg.cgi||'gcourse_pkg.courseUpdate 
	name=cf method=POST>');
	htp.p('<b><font color=red size=+1 FACE="Arial,Helvetica" >');
	htp.p('<input TYPE =submit VALUE = SUBMIT><font color=black><input type =reset  value = UNDO></font></b>');
	htp.p(' <table bgcolor=pink><th>');
	htp.p('<table bgcolor=yellow cellpadding=6 >');
	htp.p('<tr><td width=300><input type=hidden name=unum value='||unum||'>');
	htp.p('<input type=hidden name=oldtitle value='||acourse.courseTitle||'>');
	htp.p('<b>Course Title</b></td><td><input name=cname size=15 value="'||acourse.courseName||'"> ');
	htp.p('<select name=Vterm>');
	IF acourse.term='Fall' THEN
		htp.p('<option value="Fall" >Fall<option value="Spring">Spring<option value="Summer">Summer');
	ELSIF acourse.term='Spring' THEN
		htp.p('<option value="Spring">Spring<option value="Summer">Summer<option value="Fall" >Fall');
	ELSE	htp.p('<option value="Summer">Summer<option value="Fall" >Fall<option value="Spring">Spring');
	END IF;
	htp.p('</select>');
	htp.p('<input name=Vyear value='||acourse.year||' size=4><br>');
	htp.p('</td>');
	htp.p('</tr><tr><td>');
	htp.p('<b>Instructor</b></td><td><input name=Vinstructor size=30 value="'||acourse.instructor||'"></td>');
	htp.p('</tr><tr><td>');
	htp.p('<b>Instructor URL </b></td><td><input name=Vinsurl size=30 value="'||acourse.insurl||'"><br></td>');
	htp.p('</tr><tr><td>');
	htp.p('<b>Instructor email </b></td><td><input name=Vinsemail size=30 value="'||
acourse.insemail||'"><br></td>');
	htp.p('</tr><tr><td>');
	htp.p('<b>TA</b></td><td><input name=Vta size=30 value="'||acourse.ta||'"><br></td>');
	htp.p('</tr><tr><td>');
	htp.p('<b>TA URL </b></td><td><input name=Vtaurl size=30 value="'||acourse.taurl||'"><br></td>');
	htp.p('</tr><tr><td>');
	htp.p('');
	htp.p('<b>TA email </b></td><td><input name=Vtaemail size=30 value="'||acourse.taemail||'"><br></td>');
	htp.p('</tr><tr><td>');
	htp.p('<b>Other Team Names</b></td><td><input name=Vteam size=30 value="'||acourse.team||'"><br></td>');
	htp.p('</tr><tr><td>');
	htp.p('');
	htp.p('<b>Course URL</b></td><td><input name=Vurl size=30 value="'||acourse.url||'"><br></td>');
	htp.p('</tr><tr><td>');
	htp.p('');
	htp.p('<b>Number of Assignments</b></td><td><input name=Vnumberofass size=5 value="'||acourse.numberofass||'">');
	htp.p('');
	htp.p('');
	htp.p('<b>Grading Type</b>');
	htp.p('<select name=gtype >');
	htp.p('<option value="numeric" ');
IF acourse.assType='numeric' THEN
		htp.p('SELECTED');
END IF;
	htp.p('>Numeric');
	htp.p('<option value="customized"   ');
IF acourse.assType='customized' THEN
	htp.p('SELECTED');
END IF;
	htp.p('>Customized');
	htp.p('</select>');
	htp.p('<font size=-1 color=red> <input type=button value="customize" onClick="customize(this.form)">   </font>');
	htp.p('</tr><tr><td>');
	htp.p('<b>Comments</b></td><td>');
	htp.p('<textarea');
	htp.p('name="comments" rows=5 cols=30> '|| acourse.Notes||'</textarea>');
	htp.p('</tr>');
	htp.p('<tr><td><b>Select from survey questions</td><td> <font  size=-1 color=red>  <input type=button value="Survey Questions" onClick="survey(this.form)">   </font></td></tr>');
	htp.p('</table>');
	htp.p('</th>');
	htp.p('</table>');
	htp.p('<b><font color=red size=+1 FACE="Arial,Helvetica" >');
	htp.p('<input TYPE =submit VALUE = SUBMIT><font color=black><input type =reset  value = UNDO></form>');
	htp.p('</body></html>');
 -- ***end html~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	EXCEPTION
		WHEN NO_DATA_FOUND THEN
			gsystem_pkg.printErrorPage('Invalid course selection');
END courseManipulation;
--------------------------------------------------------------------
--##################################################################
-- courseManipulation
--##################################################################
PROCEDURE courseManipulation(	request IN VARCHAR2)
IS	
BEGIN
	gsystem_pkg.printErrorPage(' No course selected. Please go back and select one to continue!.');
END courseManipulation;
-------------------------------------------------------------------
-- *<*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><>*
-- *<*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><*><>*
-------------------------------------------------------------------
END gcourse_pkg;
/
show err
