CREATE OR REPLACE PACKAGE BODY gstudent_pkg AS
--------------------------------------------------------------------------------
--[*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*]
--------------------------------------------------------------------------------
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/                        _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/  STUDENT PROCEDURES     /_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_                       _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--------------------------------------------------------------------------------
--[*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*]
--------------------------------------------------------------------------------
--------------------------------------------------------------------
--##################################################################
-- studentManipulationPage
--##################################################################
PROCEDURE studentManipulationPage(	unum IN vARCHAR2,
					crsTitle IN VARCHAR2)
IS
BEGIN 
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,crsTitle,'student:studentManipulationPage') THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	htp.bp('
<html>
<title>'||crsTitle||' Students </title>
<frameset cols="200,*" border=0>
<frame src="'||gsystem_pkg.cgi||'gstudent_pkg.listStudents?unum='||unum||'&'||'crsTitle='||crsTitle||'" name=menu scrolling=yes frameborder=0 marginwidth=2 marginheight=2>
<frame src="'||gsystem_pkg.cgi||'gstudent_pkg.student?unum='||unum||'&'||'crsTitle='||crsTitle||'&'||'commMode=&'||'stdID=" name=info scrolling=yes frameborder=0>
</frameset>
<noframe>
<body bgcolor=white>
<h2>Error: You need frames for this!</h2></body></noframe>
<font size=-1><i>NPAC</i></font>
</body></html>
 	');
END studentManipulationPage;
--------------------------------------------------------------------
--##################################################################
-- listStudent
--##################################################################
PROCEDURE listStudents(unum IN VARCHAR2,crsTitle IN VARCHAR2)
IS
	student_cur 	GenericCurType;
	std		XXstudentsXX%ROWTYPE;
	courseURL	varchar2(200);
BEGIN
	SELECT url INTO courseURL FROM XXcoursesXX WHERE courseTitle=crsTitle;
	htp.p('
<html><body bgcolor=white>
<base target=info>');
	gsystem_pkg.backGuaranteed;
	htp.bp('
<table>
<tr><td>');
	IF courseURL IS NULL THEN
		htp.bp('
<img src='||gsystem_pkg.images||'homeempty.jpg border=0 align=center> </td>	
		');
	ELSE
		htp.bp('
<a href='||courseURL||'><img src='||gsystem_pkg.images||'homefull.jpg border=0></a></td>
		');
	END IF;
	htp.p('</td>
<td><b>'||crsTitle||'</b></td></tr>
<td colspan=2><hr></td></tr>
	');
	IF NOT student_cur%ISOPEN THEN      -- open the cursor if
	            gsystem_pkg.open_cv (student_cur,'XXstudentsXX',crsTitle);    -- not open yet
        END IF;
 	-- Fetch rows into PL/SQL table
	LOOP
		FETCH student_cur INTO std;
                EXIT WHEN student_cur%NOTFOUND;
			
		IF std.url IS NULL THEN
			htp.bp('
<tr><td>
<img src='||gsystem_pkg.images||'homeempty.jpg border=0 align=center> 
</td>	
			');
		ELSE
			htp.bp('
<tr><td>
<a href='||std.url||' target=stdhome><img src='||gsystem_pkg.images||'homefull.jpg border=0 align=center></a> 
</td>
			');
		END IF;
		htp.bp('
<td><a href="'||gsystem_pkg.cgi||'gstudent_pkg.student?unum='||unum||'&'||'crsTitle='||crsTitle||'&'||'commMode=SHOW&'||'stdID='||std.ssn ||'" ><b>'||	std.firstname ||' '||std.midname||' '||std.lastname||'</b></a></td></tr>
			');
        END LOOP;
        CLOSE student_cur;
	htp.bp('
<td colspan=2><hr></td></tr>
</table></body></html><font size=-1><i>NPAC</i></font>');
	gsystem_pkg.backGuaranteed;
	htp.p(' </body></html>
	');
END listStudents;
--------------------------------------------------------------------
--##################################################################
-- getPerformance(crsTitle IN VARCHAR2,stdID IN VARCHAR2,prf OUT XXperformanceXX%ROWTYPE)
--##################################################################
PROCEDURE getPerformance(crsTitle IN VARCHAR2,stdID IN VARCHAR2,prf OUT XXperformanceXX%ROWTYPE)
IS
BEGIN
	IF NOT (stdID IS NULL) THEN
		SELECT * INTO prf FROM XXperformanceXX s WHERE s.ssn=stdID AND s.course=crsTitle;
	ELSE
		NULL; --gsystem_pkg.printErrorPage('Null student id passed!.Please report to msen7@npac');
	END IF;
	EXCEPTION
	WHEN  NO_DATA_FOUND THEN
		NULL;
END ;
--------------------------------------------------------------------
--##################################################################
-- selectStudent(crsTitle IN VARCHAR2,stdID IN VARCHAR2,std OUT XXstudentSXX%ROWTYPE)
--##################################################################
PROCEDURE selectStudent(crsTitle IN VARCHAR2,stdID IN VARCHAR2,std OUT XXstudentsXX%ROWTYPE)
IS
BEGIN
	IF NOT (stdID IS NULL) THEN
		SELECT * INTO std FROM XXstudentsXX s WHERE s.ssn=stdID AND s.course=crsTitle;
	ELSE
		NULL; --gsystem_pkg.printErrorPage('Null student id passed!.Please report to msen7@npac');
	END IF;
	EXCEPTION
	WHEN  NO_DATA_FOUND THEN
		std.ssn:=stdID;
END ;
--------------------------------------------------------------------
--##################################################################
-- getHTMLformatShow(crsTitle,stdID);
--##################################################################
PROCEDURE getHTMLformatShow(uname IN VARCHAR2,crsTitle IN VARCHAR2,stdID IN VARCHAR2,buttons IN VARCHAR2,scriptMode in VARCHAR2)
IS
	std	XXstudentsXX%ROWTYPE;
--	prf	XXperformanceXX%ROWTYPE;
	script  VARCHAR2(500) DEFAULT '<script language="JavaScript">top.menu.document.location.reload();</script>';
BEGIN
	selectStudent(crsTitle,stdID,std);
--	getPerformance(crsTitle,stdID,prf);	
	htp.p('<html>');
	IF scriptMode='SHOWupdatelist' THEN
		htp.p(script);
	END IF;
	htp.bp('
<body bgcolor=white>  
<b>
<form action='||gsystem_pkg.cgi||'gstudent_pkg.commandServer
name="student" method="POST" target=info>
'||buttons ||'
<input type=hidden name=stdID  			value="'||std.ssn  ||'"> 
<input type=hidden name=pwd  			value="'||std.gspwd  ||'"> 
<input type=hidden name=std_ID  			value="'||std.student_id  ||'"> 
<input type=hidden name=fname 		size=30 value="'||std.firstname ||'">
<input type=hidden name=mname 		size=30 value="'||std.midname ||'">
<input type=hidden name=lname 		size=30 value="'||std.lastname ||'">
<input type=hidden name=dept  		size=30 value="'||std.dept  ||'">
<input type=hidden name=class		size=30 value="'||std.class||'">
<input type=hidden name=email 		size=30 value="'||std.email ||'">
<input type=hidden name=login 		size=10 value="'||std.login ||'">
<input type=hidden name=xpwd 		size=10 value="'||std.unixpwd ||'">
<input type=hidden name=url    		size=30 value="'||std.url     ||'">
<table bgcolor=blue border=5><tr><td>
<table bgcolor=yellow cellpadding=6 border=5 >
<tr><td width=300><b>Student Name</b></td><td>'||	std.firstname ||' '||std.midname||' '||std.lastname||'</td></tr>
<tr><td>	  <b>ACCESS CODE </b></td><td>'||		std.ssn ||'</td></tr>
<tr><td>	  <b>Student Records Password </b></td><td>***********</td></tr>
<tr><td>	  <b>Student-ID </b></td><td>'||	std.student_id ||'</td></tr>
<tr><td>	  <b>Department </b></td><td>'||	std.dept ||'</td></tr>
<tr><td>	  <b>Class </b></td><td>'||		std.class ||'</td></tr>
<tr><td>	  <b>email </b></td><td>'||		std.email ||'</td></tr>
<tr><td>	  <b>Unix login id </b></td><td>'||		std.login ||'</td></tr>
<tr><td>	  <b>Initial Unix Password </b></td><td>'||		std.unixpwd ||'</td></tr>
<tr><td>	  <b>url </b></td><td>'||		std.url ||'</td></tr>
</table>
</td></tr>
</table>
</form>
</b>
<hr>
</body></html>
	');
END getHTMLformatShow;
--------------------------------------------------------------------
--##################################################################
-- getHTMLformatEdit(course,stdID);
--##################################################################
PROCEDURE getHTMLformatEdit(uname IN VARCHAR2,crsTitle IN VARCHAR2,stdID IN VARCHAR2,buttons IN VARCHAR2)
IS
	std	XXstudentsXX%ROWTYPE;
--	prf	XXperformanceXX%ROWTYPE;
BEGIN
	selectStudent(crsTitle,stdID,std);	
--	getPerformance(crsTitle,stdID,prf);
	htp.p('<html>');
	htp.bp('
<body bgcolor=white>  
<b>
<form action='||gsystem_pkg.cgi||'gstudent_pkg.commandServer
name="student" method="POST" target=info>
'||buttons ||'
<table bgcolor=blue><th>
<table bgcolor=yellow cellpadding=6 >
<tr><td>	  <b>Access Code </b></td><td>		<input name=stdID value="'|| std.ssn ||'" size=9></td></tr>
<tr><td>	  <b>Student Records Password </b></td><td>	<input name=pwd type=password value="'|| std.gspwd ||'" size=9></td></tr>
<tr><td>	  <b>Student-ID </b></td><td>	<input name=std_ID value="'|| std.student_id ||'" size=15></td></tr>
<tr><td width=300><b>Student Name</b></td><td>	<table><tr>
			<td><font size=-1> FIRST </font></td><td><input name=fname value="'||std.firstname ||'" size=15>
			</td></tr><td><font size=-1>	MIDDLE </font></td><td><input name=mname value="'||std.midname ||'" size=15>
			</td></tr><td><font size=-1>	LAST </font> </td><td><input name=lname value="'||std.lastname ||'" size=15> </td></tr></table>          </td></tr>
		
<tr><td>	  <b>Department </b></td><td>	<input name=dept	value="'||std.dept ||'" size=30></td></tr>
<tr><td>	  <b>Class </b></td><td>	<input name=class	value="'||std.class ||'"></td></tr>
<tr><td>	  <b>email </b></td><td>	<input name=email	value="'||std.email ||'" size=30></td></tr>
<tr><td>	  <b>Unix Login ID</b></td><td>	<input name=login	value="'||std.login ||'" size=30></td></tr>
<tr><td>	  <b>Initial Unix Password</b></td><td>	<input name=xpwd		value="'||std.unixpwd ||'" size=30></td></tr>
<tr><td>	  <b>URL </b></td><td>		<input name=url		value="'||std.url ||'" size=30></td></tr>
</table>
</th>
</table>
</form>
</b>
<hr>
</body></html>
	');
END getHTMLformatEdit;
--------------------------------------------------------------------
--##################################################################
-- studentFunctions
--##################################################################
PROCEDURE studentFunctions(unum IN VARCHAR2,crsTitle IN VARCHAR2,commMode IN VARCHAR2, stdID IN VARCHAR2)
IS
	buttons VARCHAR2(3000);
BEGIN
	IF commMode='ADD' THEN   --  new student
		buttons:='<b> <font color=black size=+1 FACE="Arial,Helvetica" >
		<font color=red><input type=submit name=request value="ADD" > </font>
				<input type=reset  name=request value="UNDO" >
				<input type=submit name=request value="SKIP" ></font></b>';
	ELSIF commMode='EDIT' THEN 
		buttons:='<b> <font color=black size=+1 FACE="Arial,Helvetica" >	
		<font color=red><input type=submit name=request value="UPDATE" ></font>
				<input type=reset  name=request value="UNDO" >
				<input type=submit name=request value="SKIP" >
				<input type=submit name=request value="CANCEL" ></font></b>';
	ELSE    
		buttons:='<b> <font color=black size=+1 FACE="Arial,Helvetica" >	
				<input type=submit name=request value="NEW" >
		<font color=red><input type=submit name=request value="DELETE" ></font>
				<input type=submit name=request value="EDIT" >
				<input type=submit name=request value="SKIP" ></font></b>';
	END IF;
--      * ********************
	buttons:='<input type=hidden name=unum  value="'||unum ||'">
		  <input type=hidden name=course  value="'||crsTitle ||'">
		  <input type=hidden name=dbssn  value="'||stdID ||'">'||buttons;
	IF commMode like '%SHOW%' THEN
		getHTMLformatShow(unum,crsTitle,stdID,buttons,commMode);
	ELSIF  commMode='ADD' OR commMode='EDIT'  THEN
		getHTMLformatEdit(unum,crsTitle,stdID,buttons);
	END IF;
	htp.bp('</form><hr><font size=-1><i>NPAC</i></font> </body></html>');
END studentFunctions;
--------------------------------------------------------------------
--##################################################################
-- student()
--##################################################################
PROCEDURE student(unum IN VARCHAR2,crsTitle IN VARCHAR2,commMode IN VARCHAR2, stdID IN VARCHAR2)
IS
BEGIN
	IF commMode IS NULL THEN
		htp.bp('
<html><body bgcolor=white>
<b>
<form action='||gsystem_pkg.cgi||'gstudent_pkg.commandServer
method="POST" target=info>
	<input type=hidden name=unum  value="'||unum||'"> 
	<input type=hidden name=course  value="'||crsTitle||'">
	<input type=hidden name=dbssn  value="">
	<b> <font color=black size=+1 FACE="Arial,Helvetica" >
	<input type=submit name=request value="NEW"></font></b>
	<input type=hidden name=stdID  			value="'||stdID  ||'"> 
	<input type=hidden name=pwd  			value=""> 
	<input type=hidden name=std_ID  		value=""> 
	<input type=hidden name=fname 			 value="">
	<input type=hidden name=mname 			 value="">
	<input type=hidden name=lname 			 value="">
	<input type=hidden name=dept  			 value="">
	<input type=hidden name=class			 value="">
	<input type=hidden name=email 			 value="">
	<input type=hidden name=login 			 value="">
	<input type=hidden name=xpwd 			 value="">
	<input type=hidden name=url    			 value="">
<br><h2>Please click on the name of the student which you want to manipulate!</h2>
		');
	ELSE studentFunctions(unum ,crsTitle, commMode , stdID );
	END IF;
END student;
/*_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_SQL OPERATIONS on DATABASE/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_ COMMAND SERVER are below/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/*/
--------------------------------------------------------------------
--##################################################################
--changeOwnerIds(dbssn,stdID); 
--##################################################################
-- ASSSUMING THIS RECORD EXIST ; otherwise this function could not be called; in case of external usage
-- check the existence
PROCEDURE changeOwnerIds(old IN VARCHAR2,new IN VARCHAR2)
IS
BEGIN
	UPDATE XXgradesXX g
	SET  	
	g.ssn=new
	WHERE g.ssn=old;
	COMMIT;
	UPDATE XXperformanceXX x SET  x.ssn=new WHERE x.ssn=old; COMMIT;
	UPDATE XXsurveyXX x SET  x.ssn=new WHERE x.ssn=old; COMMIT;
--	UPDATE XXXX x SET  x.ssn=new WHERE x.ssn=old; COMMIT;
--	UPDATE XXXX x SET  x.ssn=new WHERE x.ssn=old; COMMIT;
END changeOwnerIds;
--------------------------------------------------------------------
--##################################################################
-- addStudent(crsTitle,stdID,gBase,url,commUrl,notes);
--##################################################################
PROCEDURE addStudent(crsTitle IN VARCHAR2, stdID IN VARCHAR2,pwd IN VARCHAR2,std_id IN NUMBER, fname  iN VARCHAR2, mname  iN VARCHAR2, lname  iN VARCHAR2, dept IN VARCHAR2, class IN VARCHAR2, email IN VARCHAR2,login IN VARCHAR2,xpwd IN VARCHAR2, url IN VARCHAR2)
IS
BEGIN
	INSERT INTO XXstudentsXX
	VALUES (stdID,pwd,crsTitle,std_id,fname,mname,lname, class ,dept ,email,login, xpwd,url);
	IF SQL%NOTFOUND THEN
		gsystem_pkg.printErrorPage('System failed to add!');	
	END IF;
--	INSERT INTO XXperformanceXX
--	VALUES (stdID,crsTitle, grade , average,premark , taremark , sremark);
--	IF SQL%NOTFOUND THEN
--		gsystem_pkg.printErrorPage('System failed to add!');	
--	END IF;

	COMMIT;
	EXCEPTION
		WHEN DUP_VAL_ON_INDEX THEN
			gsystem_pkg.printErrorPage('This student number,'||stdID||' already exists! You may update it, but duplication is not allowed!');
		WHEN INVALID_NUMBER THEN
			gsystem_pkg.printErrorPage('This student number,'||stdID||' is not valid number, please check it and try again!');
END addStudent;
--------------------------------------------------------------------
--##################################################################
-- updateStudent(crsTitle,stdID,maxGrade,commentUrl,notes);
--##################################################################
PROCEDURE updateStudent(VcrsTitle IN VARCHAR2,VoldstdID IN VARCHAR2,VstdID IN VARCHAR2,Vpwd IN VARCHAR2,Vstd_ID IN NUMBER,Vfname IN VARCHAR2,Vmname IN VARCHAR2,Vlname IN VARCHAR2,Vdept IN VARCHAR2,Vclass IN VARCHAR2,Vemail IN VARCHAR2,Vlogin IN VARCHAR2,Vxpwd IN VARCHAR2,Vurl IN VARCHAR2)
IS
	notupdated EXCEPTION;
BEGIN
	UPDATE XXstudentsXX s
	SET  	
	s.ssn=VstdID  ,
	s.gspwd=Vpwd,
	s.student_id=Vstd_ID  ,
	s.course=VcrsTitle ,
	s.firstname=Vfname 	,s.midname=Vmname 	,s.lastname=Vlname 	,
	s.dept=Vdept ,
	s.class=Vclass	,
	s.email =Vemail ,
	s.login =Vlogin ,	
	s.unixpwd =Vxpwd ,	
	s.url =Vurl  
	WHERE s.course=VcrsTitle AND s.ssn=VoldstdID;
	COMMIT;
	IF SQL%NOTFOUND THEN RAISE notupdated; END IF;
--	UPDATE XXperformanceXX s
--	SET  	
--	s.ssn=VstdID  ,
--	s.course=VcrsTitle ,
--	s.grade=Vgrade ,
--	s.average=Vavg ,	
--	s.public_remark=Vpremark	
--	WHERE s.course=VcrsTitle AND s.ssn=VoldstdID;
--	COMMIT;
--	IF SQL%NOTFOUND THEN RAISE notupdated; END IF;
--	IF NOT Vtaremark IS NULL THEN
--			UPDATE XXperformanceXX s
--			SET  s.ta_remark=Vtaremark	
--			WHERE s.course=VcrsTitle AND s.ssn=VstdID;
--			COMMIT;
--			IF SQL%NOTFOUND THEN RAISE notupdated; END IF;
--	END IF;
--	IF NOT Vsremark IS NULL THEN
--			UPDATE XXperformanceXX s
--			SET  s.secret_remark=Vsremark	
--			WHERE s.course=VcrsTitle AND s.ssn=VstdID;
--			COMMIT;
--			IF SQL%NOTFOUND THEN RAISE notupdated; END IF;
--	END IF;
	EXCEPTION
		WHEN notupdated THEN
			gsystem_pkg.printErrorPage('System failed to update! !');
			--addStudent(VcrsTitle,VstdID,Vname,Vdept,Vclass,Vemail,Vurl,Vgrade,Vavg,Vpremark,Vtaremark,Vsremark);
END updateStudent  ;
--------------------------------------------------------------------
--##################################################################
-- deleteStudent(crsTitle,stdID);
--##################################################################
PROCEDURE deleteStudent(VcrsTitle IN VARCHAR2,VstdID IN VARCHAR2)
IS
BEGIN
	DELETE FROM XXstudentsXX s
	WHERE s.course=VcrsTitle AND s.ssn=VstdID;
	COMMIT;
	IF SQL%NOTFOUND THEN
		gsystem_pkg.printErrorPage('System failed to delete!<br> Record may be deleted already!');
	END IF;
	DELETE FROM XXsurveyXX s WHERE s.course=VcrsTitle AND s.ssn=VstdID;
	DELETE FROM XXgradesXX s WHERE s.course=VcrsTitle AND s.ssn=VstdID ;	
	DELETE FROM XXperformanceXX s WHERE s.course=VcrsTitle AND s.ssn=VstdID ;	
	COMMIT;
END deleteStudent;
--------------------------------------------------------------------	  **
--##################################################################	******
-- commandServer							  **
--##################################################################	 *  *	
PROCEDURE commandServer(unum IN VARCHAR2,course IN VARCHAR2,dbssn IN VARCHAR2,request IN VARCHAR2, stdID IN VARCHAR2,pwd IN VARCHAR2, std_ID IN NUMBER,
fname  iN VARCHAR2,mname  iN VARCHAR2,lname  iN VARCHAR2, dept IN VARCHAR2, class IN VARCHAR2, email IN VARCHAR2,login IN VARCHAR2,xpwd IN VARCHAR2, url IN VARCHAR2)
IS  
	name VARCHAR2(100);
BEGIN  
	IF request='ADD' THEN
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,course,'student:CS:'||request) THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
		name:=fname ||mname|| lname;
		IF stdID IS NULL THEN
			gsystem_pkg.printErrorPage('SSN should not be empty!.');
			RETURN;
		ELSIF name IS NULL THEN
			gsystem_pkg.printErrorPage('Name Fields should not be empty!.');
			RETURN; 
		END IF;
		addStudent(course,stdID,pwd,std_ID,fname,mname,lname ,dept,class ,email,login,xpwd, url );
		student(unum,course,'SHOWupdatelist',stdID);
	ELSIF request='NEW' THEN
		student(unum,course,'ADD',NULL);
	ELSIF request='DELETE' THEN
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,course,'student:CS:'||request) THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
		deleteStudent(course,stdID);
		htp.p('<html> <script language=JavaScript> top.document.location.reload();</script></html>');
	ELSIF request='UPDATE' THEN
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
	IF  NOT gsystem_pkg.accessPermit(unum,course,'student:CS:'||request) THEN
		RETURN;
	END IF;
--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
		updateStudent(course,dbssn,stdID,pwd,std_ID,fname,mname,lname,dept , class ,email,login,xpwd,url );
		IF (NOT dbssn IS NULL) AND (NOT dbssn=stdID) THEN
			changeOwnerIds(dbssn,stdID);
		END IF;
		student(unum,course,'SHOWupdatelist',stdID);
	ELSIF request='EDIT' THEN
		student(unum,course,'EDIT',stdID);
	ELSIF request='CANCEL' THEN
		htp.p('<html> <script language=JavaScript> history.go(-2);</script></html>');
		student(unum,course,NULL,NULL);
	ELSIF request='SKIP' THEN
		student(unum,course,NULL,NULL);
	ELSIF request='SHOW' THEN
		getHTMLformatShow(unum,course,stdID,NULL,NULL);
--	ELSIF request='PWDASSIGN' THEN
	END IF;
END commandServer;
/*
--------------------------------------------------------------------
PROCEDURE commandServer(unum IN VARCHAR2,course IN VARCHAR2,dbssn IN NUMBER,request IN VARCHAR2, stdID IN VARCHAR2,pwd IN VARCHAR2,std_ID IN NUMBER, fname  iN VARCHAR2, mname  iN VARCHAR2, lname  iN VARCHAR2, dept IN VARCHAR2, class IN VARCHAR2, email IN VARCHAR2,login IN VARCHAR2,xpwd IN VARCHAR2, url IN VARCHAR2, grade IN VARCHAR2,average IN VARCHAR2,  premark IN VARCHAR2, taremark IN VARCHAR2)
IS  
BEGIN  
	commandServer(unum,course,dbssn,request,stdID,std_ID,fname,mname,lname,dept,email,login, xpwd,url,grade,average,premark,taremark,NULL);
END commandServer;
--------------------------------------------------------------------
PROCEDURE commandServer(unum IN VARCHAR2,course IN VARCHAR2,dbssn IN NUMBER,request IN VARCHAR2, stdID IN VARCHAR2,pwd IN VARCHAR2,std_ID IN NUMBER, fname iN VARCHAR2, mname iN VARCHAR2, lname iN VARCHAR2, dept IN VARCHAR2, class IN VARCHAR2, email IN VARCHAR2, login IN VARCHAR2,xpwd IN VARCHAR2,url IN VARCHAR2, grade IN VARCHAR2,average IN VARCHAR2,  premark IN VARCHAR2)
IS  
BEGIN 
	commandServer(unum,course,dbssn,request,stdID,std_ID,fname,mname,lname,dept,class,email,login, xpwd,url,grade,average,premark,NULL,NULL);
END commandServer;
*/
--------------------------------------------------------------------------------
--[*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*][*]
--------------------------------------------------------------------------------
END gstudent_pkg;
/
show err